/***************************************************************************
 *   Copyright (C) 2006 by BardaK   *
 *   bardak@BardaX   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdio.h>

unsigned long bencodeSkipChars(const char* pointer) {
    unsigned long skippedChars = 0;
    if(isdigit(*pointer)) {
	    int numchars = strchr(pointer, ':')-pointer;
	    char * tempBuff=(char*)malloc(numchars+1);
	    tempBuff[numchars]=0;
	    strncpy(tempBuff, pointer, numchars);
	    skippedChars += numchars + 1 + atoi(tempBuff);
	    free(tempBuff);
	    pointer += skippedChars;
    } else if(*pointer == 'd' || *pointer == 'l') {
	    ++skippedChars;
	    while(*(pointer+skippedChars) != 'e')
		    skippedChars+= bencodeSkipChars((pointer+skippedChars));
	    ++skippedChars;
    } else if(*pointer == 'i')
	    skippedChars += 1 + (strchr(pointer, 'e')-pointer);
	    else{
		    fprintf(stderr, "Malformed bencode\n");
		    exit(1);
	    }
	return skippedChars;
	   
}

inline char startsWith(const char* string, const char* pattern, int length){
	if(length < strlen(pattern)) return 0;
	int i = 0;
	for(; i < strlen(pattern); i++)
		if(string[i] != pattern[i])
			return 0;
	return 1;
}

int decodeString(char* destination, const char* buffer){
	int ret = 0;
	int numchars = strchr(buffer,':')-buffer;
	ret += numchars+1;
	if(numchars == -(int)buffer) 
		return -1;
	char*  tempBuff = (char*)malloc(numchars+1);
	if(!tempBuff){
		return -1;
	}
	tempBuff[numchars]=0;
	strncpy(tempBuff, buffer, numchars);
	buffer += numchars +1;
	ret += atoi(tempBuff);
	strncpy(destination, buffer, atoi(tempBuff));
	free(tempBuff);
	return ret;
}

int decodeInt(int* destination, const char* buffer){
	buffer ++;
	int ret = 1;
	int numchars = strchr(buffer,'e')-buffer;
	char*  tempBuff = (char*)malloc(numchars+1);
	ret += numchars;
	tempBuff[numchars]=0;
	strncpy(tempBuff, buffer, numchars);
	ret +=1;
	*destination = atoi(tempBuff);
	free(tempBuff);
	return ret;
}